]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - macros.pld
- remove duplicate macros
[packages/rpm-build-macros.git] / macros.pld
CommitLineData
7982022e
ER
1# vim:ts=4 sw=4 noet ft=spec
2#
f51bfb2f
ER
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
d54662bf 5
2b05614d 6# can be used by builder script to check for version
2fb1b7ce 7%rpm_build_macros {Revision}
98c5c988 8
e05017c1 9%epoch 0
3241033b 10%x8664 x86_64 amd64 ia32e
9c404149 11
46763914 12# compiler version
eab5f7f4
ER
13%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
14%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
46763914 15
69bcfbf3 16%__rm /bin/rm --interactive=never
36eccf0d 17
33040789 18# Build system path macros.
69bcfbf3
ER
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
21%__autopoint autopoint --force
22
23# add parallel build flags: -jN
82f23c63 24# jobs macro is available since 1.657
a5656a95 25#
11ecb0a1 26# if you want to disable parallel build do:
82f23c63 27# echo '%__jobs %{nil}' >> ~/.rpmmacros
799bf7ab 28%__jobs %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
82f23c63
ER
29
30# expands to -jN if %__jobs has a value
31%_smp_mflags %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
32
8579c486 33%__make /usr/bin/make %{?_make_opts} %{?_smp_mflags}
11ecb0a1
ER
34%__scons /usr/bin/scons %{?_smp_mflags}
35%__waf /usr/bin/waf %{?_smp_mflags}
fa16fde1 36%__cmake /usr/bin/cmake -Wno-dev
f72d45c4 37%__meson /usr/bin/meson
9cfca9d1
AM
38%__meson_wrap_mode nodownload
39%__ninja /usr/bin/ninja
40%__ninja_common_opts -v %{?_smp_mflags}
a5656a95 41
83094b62 42%__gettextize { \
b8dd0565 43 gettextize --copy --force --no-changelog; \
8a995cff 44 if [ ! -f po/Makevars ]; then \
3241033b 45 cp -f po/Makevars{.template,}; \
8a995cff 46 fi; \
8a995cff 47}
f93109a0 48
49%__glib_gettextize glib-gettextize --copy --force
50%__gnome_doc_common gnome-doc-common --copy
fb59e475 51%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 52%__gtkdocize gtkdocize --copy
53%__intltoolize intltoolize --copy --force
c26f1b59 54%__libtoolize libtoolize --copy --force --install
33040789 55
751c2bdd
ER
56# topdir is where builder script lives,
57# fallback to old style if SPECS/SOURCES dirs were found.
58%_topdir %{expand:%%global _topdir %(
59 if [ -d SPECS -a -d SOURCES ]; then
60 # old style rpmdir: in topdir
df3151c2 61 pwd
751c2bdd
ER
62 elif [ -d ../SPECS -a -d ../SOURCES ]; then
63 # old style rpmdir: in subdir
df3151c2 64 cd ..; pwd
751c2bdd
ER
65 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
66 # if old style rpm dir exist, go with it
67 echo $HOME/rpm; \
68 elif [ -x ../builder -a ! -d ../builder ]; then
69 # relative new style rpmdir: in package dir
df3151c2 70 cd ..; pwd
751c2bdd
ER
71 elif [ -x builder -a ! -d builder ]; then
72 # relative new style rpmdir: in packages
df3151c2 73 pwd
751c2bdd
ER
74 elif [ -x packages/builder -a ! -d packages/builder ]; then
75 # relative new style rpmdir: packages dir in current dir
df3151c2 76 cd packages; pwd
751c2bdd
ER
77 else
78 # fallback to new style rpmdir
79 echo $HOME/rpm/packages
80 fi; \
81)}%_topdir
1052b4b8 82
751c2bdd 83# if %{_topdir}/SPECS exists, it's old style structure
3303369c 84%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
751c2bdd 85%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8 86
af9d1e61 87# BUILD/RPMS/SRPMS are on same level by default as packages dir, if these exist
1052b4b8
ER
88# if they don't exist assume we are having custom topdir (which is not named as
89# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
af9d1e61 90# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therefore the extra echo
df3151c2
ER
91%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
92%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
93%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 94
81e450f7
ER
95# The number of cvs changelog entries kept when building package.
96%_buildchangelogtruncate 20
97
6a5eda77 98%dependencytracking %{nil}
3241033b 99
e5da9169
ER
100# Relations between package names that cause dependency loops
101# with legacy packages that cannot be fixed. Relations are
102# specified as
103# p>q
104# where package p has a Requires: on something that package q Provides:
105#
106# XXX Note: that there cannot be any whitespace within the string "p>q",
107# and that both p and q are package names (i.e. no version/release).
108%_dependency_whiteout %{nil}
109
810fa5c4 110#-----------------------------------------------------------------
111#
112# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
113# BuildRequires: awk
114# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 115#
116# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 117# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
118# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 119# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 120# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 121#
122# Regular expressions are supported, but to avoid some character be treated
123# as regular expression it must be escaped twice.
124
048f3050
JR
125%filter_out \
126 for (i = 1; i in I; i++) { A=0; \
810fa5c4 127 for (f in F) { \
128 if (I[i] ~ "^" F[f] "$") A=1; \
129 }; \
130 if (!A) printf(I[i] FS); \
131 }
132
133%rpmcflags %(awk 'BEGIN {
134 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 135 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 136 %{filter_out}
137}')
138
139%rpmcxxflags %(awk 'BEGIN {
09a90176 140 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
141 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 142 %{filter_out}
143}')
144
98e7f050
AM
145%rpmcppflags %(awk 'BEGIN {
146 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
147 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
148 %{filter_out}
149}')
150
810fa5c4 151%rpmldflags %(awk 'BEGIN {
c05a0741 152 split("%{?optldflags}",I);
810fa5c4 153 split("%{?filterout_ld}",F)
154 %{filter_out}
155}')
156
25f52d1a 157# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
158# but, don't use it, better use gcc as linker
159%ld_rpmldflags %(awk 'BEGIN {
160 split("%{rpmldflags}",F);
161 for (f in F) {
162 s = F[f];
163 if (s ~ /^-Wl,/) {
164 s = substr(s,5);
165 gsub(/,/," ",s);
166 };
167 printf(s FS);
168 };
169}')
170
8ef644e5 171#-----------------------------------------------------------------
172#
173# Generate a command which cleans environment, leaving only the
174# most important variables.
175# If any spec requires any additional environment it should
176# redefine %_preserve_env in following manner:
177#
178# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 179# %define _preserve_env ADDITIONAL_VAR
8ef644e5 180
57ba0f59 181%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 182
bb597f2b 183# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
7c0a3893
MK
184%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
185 split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
a363d727
ER
186 for (i in P) {
187 p = P[i];
82d10503
ER
188 if (!ENVIRON[p] || d[p]) {
189 continue;
8ef644e5 190 }
82d10503
ER
191 d[p] = 1;
192 split(ENVIRON[p], V, "");
193 val = p "=";
194 for (j = 1; j in V; j++) {
195 v = V[j];
196 if (v == q)
197 v = qq;
198 else if (v == "\\"")
199 v = q2q;
200 else if (v == "\\\\")
201 v = "\\\\\\\\";
202 else
203 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
204 val = val "" v;
205 }
206 printf(val " ");
8ef644e5 207 }
208}')
209
dd64e428
JK
210# override %__spec_build_pre and %__spec_install_pre from macros.rpmbuild
211# adding %{_clean_env}
212%__spec_build_pre %{_clean_env}\
213%{___build_pre}\
214%{nil}
215%__spec_install_pre %{_clean_env}\
216%{___build_pre}\
217%{?buildroot:%{__rm} -rf '%{buildroot}'; %{__mkdir_p} '%{buildroot}'}\
218%{nil}
219
9c404149 220#-----------------------------------------------------------------
9f4ce098 221%configure2_13 { \
9c404149
AM
222 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
223 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
224 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 225 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 226 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 227 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 228 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
229 %{?__cc:CC="%{__cc}" ; export CC ; } \
230 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 231 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 232 --host=%{_target_platform} \
048f3050 233 --prefix=%{_prefix} \
9c404149
AM
234 --exec-prefix=%{_exec_prefix} \
235 --bindir=%{_bindir} \
236 --sbindir=%{_sbindir} \
237 --sysconfdir=%{_sysconfdir} \
238 --datadir=%{_datadir} \
239 --includedir=%{_includedir} \
240 --libdir=%{_libdir} \
241 --libexecdir=%{_libexecdir} \
242 --localstatedir=%{_localstatedir} \
243 --sharedstatedir=%{_sharedstatedir} \
244 --mandir=%{_mandir} \
245 --infodir=%{_infodir} \
b6c5da52 246 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 247 %{dependencytracking} \
9c404149
AM
248}
249
b6ce5bb6
JB
250# Note: pass only standard cmake macros here.
251# The only exception is SYSCONF_INSTALL_DIR, used commonly in KDE packages,
252# where the default (${CMAKE_INSTALL_PREFIX}/etc) is not FHS-compliant and
253# absolute path MUST be used to comply with FHS.
254# The other non-standard cmake macros used commonly in KDE
255# (INCLUDE_INSTALL_DIR, LIB_INSTALL_DIR, SHARE_INSTALL_PREFIX)
256# have sane default values in KDE, and some packages use these names
257# in different way (e.g. expect them to be always relative or always
258# absolute).
c4a85bd8 259%cmake \
018307da
ER
260%{?__cc:CC="${CC:-%{__cc}}"} \\\
261%{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
d41caea6 262CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
c4a85bd8 263%{__cmake} \\\
8736ae44 264 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
547ff095 265 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
e23de4fc
AM
266 -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \\\
267 -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \\\
268 -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \\\
269 -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
270 -DCMAKE_INSTALL_SHAREDSTATEDIRPATH:PATH=%{_sharedstatedir} \\\
271 -DCMAKE_INSTALL_LOCALSTATEDIRPATH:PATH=%{_localstatedir} \\\
8736ae44 272 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
e23de4fc
AM
273 -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \\\
274 -DCMAKE_INSTALL_OLDINCLUDEDIR:PATH=%{_includedir} \\\
275 -DCMAKE_INSTALL_DATAROOTDIR:PATH=%{_datadir} \\\
276 -DCMAKE_INSTALL_DATADIR:PATH=%{_datadir} \\\
277 -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \\\
278 -DCMAKE_INSTALL_LOCALEDIR:PATH=%{_localedir} \\\
279 -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \\\
280 -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir} \\\
8736ae44 281 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
8736ae44 282 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
1271c350
AM
283 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
284 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
285 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
547ff095
KK
286 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
287 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
288 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
c27b3ff8 289%if "%{_lib}" == "lib64" \
c4a85bd8 290 -DLIB_SUFFIX=64 \\\
a5e43006
JR
291%endif \
292%if "%{_lib}" == "libx32" \
293 -DLIB_SUFFIX=x32 \\\
9d1e0c01 294%endif \
8736ae44 295 -DBUILD_SHARED_LIBS:BOOL=ON \\\
c4a85bd8 296%{nil}
89f4ca1f 297
89f4ca1f
ER
298%scons { \
299%{__scons} \
5c76736d
ER
300 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
301 CFLAGS="${CFLAGS:-%rpmcflags}" \
302 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
303 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 304 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
305 %{?__cc:CC="%{__cc}"} \
306 %{?__cxx:CXX="%{__cxx}"} \
307 libsuffix=%{_lib} \
308 prefix=%{_prefix} \
39b9534b
ER
309}
310
6339d32d 311# waf. see waf.spec
6339d32d 312%waf { \
6339d32d
ER
313CC="%{__cc}" \
314CXX="%{__cxx}" \
9e244007 315CPP="%{__cpp}" \
6339d32d
ER
316CFLAGS="%{rpmcflags}" \
317CXXFLAGS="%{rpmcxxflags}" \
32c27cc0 318LINKFLAGS="%{rpmldflags}" \
6339d32d 319%{__waf} \
6339d32d
ER
320}
321
f72d45c4
JP
322# meson
323%meson { \
324%{?__cc:CC="${CC:-%{__cc}}"} \
325%{?__cxx:CXX="${CXX:-%{__cxx}}"} \
326CFLAGS="${CFLAGS:-%{rpmcflags}}" \
327CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \
328CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \
329LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \
e2329ed5 330LC_ALL=C.UTF-8 %{__meson} \
f72d45c4 331 --buildtype=plain \
4cb9865f 332 --bindir=%{_bindir} \
4cb9865f
JP
333 --datadir=%{_datadir} \
334 --includedir=%{_includedir} \
9cfca9d1 335 --infodir=%{_infodir} \
4cb9865f
JP
336 --libdir=%{_libdir} \
337 --libexecdir=%{_libexecdir} \
9cfca9d1 338 --localedir=%{_localedir} \
4cb9865f 339 --localstatedir=%{_localstatedir} \
4cb9865f 340 --mandir=%{_mandir} \
9cfca9d1
AM
341 --prefix=%{_prefix} \
342 --sbindir=%{_sbindir} \
343 --sharedstatedir=%{_sharedstatedir} \
344 --sysconfdir=%{_sysconfdir} \
345 --wrap-mode=%{__meson_wrap_mode} \
bc702a45 346 --default-library='both' \
f72d45c4 347}
003c1a6e
ER
348
349%___meson_deprecate() {echo >&2 "DEPRECATED: %%%1 must be replaced with %%%2"; %{expand:%%%2} }
350%meson_build %___meson_deprecate meson_build ninja_build
351%meson_install %___meson_deprecate meson_install ninja_install
352%meson_test %___meson_deprecate meson_test ninja_test
f72d45c4
JP
353
354# ninja
003c1a6e
ER
355%ninja_build LC_ALL=C.UTF-8 %{__ninja} %{__ninja_common_opts}
356%ninja_install LC_ALL=C.UTF-8 DESTDIR=%{buildroot} %{__ninja} install %{__ninja_common_opts}
357%ninja_test LC_ALL=C.UTF-8 %{__ninja} test %{__ninja_common_opts}
f72d45c4 358
4a6b0d54 359#----------------------------------------------------------------
9bacbb5b 360#%configure_cache 0
fe6c4bdd 361%configure_cache_file %{buildroot}.configure.cache
73f832b3 362
e84cd836 363%configure {./configure \
048f3050 364 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
4a6b0d54 365 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 366 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 367 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 368 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 369 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
370 %{?__cc:CC="%{__cc}"} \
371 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 372 --host=%{_target_platform} \
4a6b0d54 373 --build=%{_target_platform} \
048f3050 374 --prefix=%{_prefix} \
4a6b0d54
AF
375 --exec-prefix=%{_exec_prefix} \
376 --bindir=%{_bindir} \
377 --sbindir=%{_sbindir} \
378 --sysconfdir=%{_sysconfdir} \
379 --datadir=%{_datadir} \
380 --includedir=%{_includedir} \
381 --libdir=%{_libdir} \
382 --libexecdir=%{_libexecdir} \
383 --localstatedir=%{_localstatedir} \
384 --sharedstatedir=%{_sharedstatedir} \
385 --mandir=%{_mandir} \
386 --infodir=%{_infodir} \
b6c5da52 387 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 388 %{dependencytracking} \
9bacbb5b 389 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
390}
391
611a25d5 392# Simple macros to simplify adding bconded options to configure scripts.
393# Each macro requires bcond name and accepts optional option name, if option
394# isn't specified bcond name is used as option name. Options returning
395# --with and --enable also allow third argument which will be added as value
396# ( --with-option=value or --enable-option=value ) in case or positive
397# condition, but won't be added otherwise ( nothing or just --disable-option ).
398
399# Requirements:
400# BuildRequires: rpmbuild(macros) >= 1.527
401
402# Usage example:
403# %{__enable bcond} - returns --enable-bcond iff build condition is set
404# %{__disable bcond option} - returns --enable-option iff bcond is not set
405# %{__enable_disable bcond option value} - returns --enable-option=value if
406# bcond is set, returns --disable-option otherwise
407
408# expand bconds to --enable-something and --disable-something
409%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
410%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
411%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
412
413# same as above, but condition inverted
414%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
415%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
416%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
417
418# expand bconds to --with-something and --without-something
419%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
420%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
421%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
422
423# same as above, but condition inverted
424%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
425%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
426%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
427
f51f5213 428# expands to true or false based on bcond; for use with meson or cmake
d9ea8286 429%__true_false() %{expand:%%{?with_%{1}:true}%%{!?with_%{1}:false}}
66ce621b 430%__true_false_not() %{expand:%%{?with_%{1}:false}%%{!?with_%{1}:true}}
d9ea8286 431
84b57058 432# for use with cmake:
7cafb58f 433# Usage: cmake_on_off BCOND_NAME [OPTION_NAME]
84b57058
AG
434# BuildRequires: rpmbuild(macros) >= 1.742
435%cmake_on_off() -D%{?2}%{!?2:%{1}}:BOOL=%{expand:%%{?with_%{1}:ON}%%{!?with_%{1}:OFF}}
436
611a25d5 437#-----------------------------------------------------------------
438
b3b1397b
ER
439# overload to insert debuginfo package
440%prep \
441%if 0%{?_enable_debug_packages}\
442%{debug_package}\
443%endif\
444%%prep\
445%{nil}
446
9c404149 447# Location of autoconf macros
ef7d5e14 448%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
9c404149 449
e2804f99 450# Location of omf files
7f0f4a79 451%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 452
e987a186 453# Location of pkgconfig files
9a4e877a 454%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
455# noarch pkgconfig files
456%_npkgconfigdir /usr/share/pkgconfig
e987a186 457
486b0b5f 458# Location of desktop files
459%_desktopdir /usr/share/applications
86dff2d0 460%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 461
481463e9 462# Location of pixmaps for applnk/desktop files
e1f0a822 463%_pixmapsdir /usr/share/pixmaps
9c404149 464
481463e9 465# Location of themable icons for applnk/desktop files
b36c8e2a 466%_iconsdir /usr/share/icons
467
e987a186
JB
468# Location of fonts directories
469%_fontsdir /usr/share/fonts
470
b3282f3f 471# Location of Gtk and associated libraries documentation
fe6c4bdd 472%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 473
fc4d7771 474# Location of KDE documentation
fe6c4bdd 475%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 476
5869828c 477# unsermake script
478%__unsermake /usr/share/unsermake/unsermake
479
9c404149 480# Current date
048f3050 481%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 482
9c404149
AM
483# Example files, programs, scripts...
484%_examplesdir /usr/src/examples
485
c0fe61f0
ER
486# SysV-style initscripts dir
487%_initddir /etc/rc.d/init.d
488
9c404149 489# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 490%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 491
590bc1db 492# Bootstrap release macros.
493# Usage:
494# %bcond_with bootstrap
495# Release: %{bootstrap_release 1}
496#
497# Package will have release 1 if built normally,
498# and release 0.zzz.bootstrap if built with bootstrap
499%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
500
410df6e8
ER
501# Requires name = version-release
502%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 503# Requires: name = version
91d2f1eb 504%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 505# Requires: name = version (version based on querying package %2)
0d3e64c0 506%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 507
90c674d3
JR
508# Requires: name >= version
509%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
510# Requires: name >= version (version based on querying package %2)
511%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
512
048f3050 513# helper for renaming packages
807b9424
JR
514# %rename old-package
515%rename() \
516Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
048f3050 517Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
807b9424 518
c94807f3 519%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 520
e00dd7f6 521# sgml macros
3241033b
ER
522%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
523%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
524%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
525%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
526%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
527%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 528%docbook_sgmlcat_fix() { for l in \
529'' \
530' -- default decl --' \
531'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
532' -- hacks for opensp --' \
533'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
3303369c 534'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
e00dd7f6 535'' \
536; do echo $l; done >> %1 \
537}
538
eea64748
ER
539# vim - "
540
4f044018
ER
541# minimum file size needed for compressed documents.
542# just smaller files than this get larger when compressed.
a88ae20f
ER
543# some stats:
544# - 0 byte file compressed was 25 bytes .gz
545# - 39 byte file was compressed as 57
546# - with test/test.spec@man 158 byte file was compressed also 158
547%_min_compress_bytes 159
4f044018 548
9c404149
AM
549#-----------------------------------------------------------------
550# find and gzip all files in %{_mandir} and %{infodir}
551#
552# Requires: xargs, find
553#
554#%no_install_post_compress_docs 1
555%__spec_install_post_compress_docs { \
53d5af13 556%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
f58a5195 557 %{!?debug:set +x;} \
4e10ec06 558 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 559 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 560 echo "Compress man pages: $i"; \
f1e00d64
AM
561 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
562 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
6375241c 563 find $RPM_BUILD_ROOT$i -type l | while read a; do \
9774b98f 564 m=$(readlink "$a"); \
7d032b46
ER
565 if [[ "$m" = */* ]]; then \
566 # handle links to different man section \
567 l=$(readlink -f "$a"); \
568 # full/relative paths that resolve symlink \
569 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
570 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
571 # full paths that do not resolve symlink \
572 l=${l#/usr/share/man/}; \
573 l=${l#/usr/X11R6/man/}; \
574 else \
5b7659c8
JR
575 l=${a#$RPM_BUILD_ROOT$i/}; \
576 l=${l%/*}; \
577 l="$l/$m"; \
7d032b46 578 fi; \
6375241c 579 rm -f $a; \
9774b98f
ER
580 echo ".so $l" > $a; \
581 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
6375241c 582 done; \
5ae32dbb
JB
583 # verify that .so links point to existing files (not allowed to point to "other package") \
584 # TODO: iterate over all man dirs, but in Th there is only one true man dir \
b012dc65 585 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
e5637efc 586 l=$(grep -r '^\.so ' "$doc"); \
b012dc65 587 l=${l#.so }; \
b27f6a7a 588 d=$(dirname $doc); \
0f7dd079 589 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
b012dc65
ER
590 done); \
591 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
f1e00d64 592 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
9c404149
AM
593 fi; \
594 done; \
728ad671
JB
595 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
596 echo "Compress info pages: %{_infodir}"; \
f1e00d64
AM
597 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
598 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
599 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
4e10ec06 600 fi; \
53d5af13 601}; __spec_install_post_compress_docs } }
9c404149
AM
602
603#-----------------------------------------------------------------
604# Strip executable binaries and shared object files
605#
606# Requires: find, awk, strip, cut, xargs
607#
a2ad2754
JB
608# Special macros which affect this process:
609#%no_install_post_strip 1 # disable stripping at all
610#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
611#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
612#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
613#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
614#
9c404149 615%__spec_install_post_strip {%{!?debug: \
53d5af13 616%{!?no_install_post_strip:__spec_install_post_strip() { \
f58a5195 617%{!?debug:set +x;} \
98a06bad 618if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748 619 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
cbfd7965 620 modulelist=$(find $RPM_BUILD_ROOT/lib/modules \( -name '*.o' -o -name '*.ko' \) -type f -print); \
4d5370ac
ER
621 if [ "$modulelist" ]; then \
622 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 623 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34 624 echo "$modulelist" | xargs -l512 chmod u+w; \
f0b25c9c 625 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
3df8db34
ER
626 echo "DONE"; \
627 fi; \
eea64748 628 fi; \
0b083a56 629 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[x0-9]*/debug/.*\.debug" ! -regex ".*/usr/lib[x0-9]*.*/guile/.*\.go" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
630 if [ -n "$filelist" ]; then \
631 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
632 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
633 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 634 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 635 if [ -n "$elfexelist" ]; then \
4d5370ac 636 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
6a7faaa9
ER
637 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
638 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
f89ccb5f
JB
639 echo "DONE"; \
640 fi; \
641 if [ -n "$elfsharedlist" ]; then \
4d5370ac 642 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
6a7faaa9
ER
643 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
644 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
f89ccb5f
JB
645 echo "DONE"; \
646 fi; \
647 if [ -n "$archiveslist" ]; then \
4d5370ac 648 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
6a7faaa9
ER
649 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
650 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
f89ccb5f
JB
651 echo "DONE"; \
652 fi; \
98a06bad 653 fi; \
0ac49134
ER
654 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
655 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
656 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 657 if [ -n "$filelist_all" ]; then \
4d5370ac 658 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 659 chmod u+w $filelist_all; \
f89ccb5f 660 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 661 echo "DONE"; \
9c404149 662 fi; \
f89ccb5f 663 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 664 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 665 chmod u+w $filelist_unneeded; \
f89ccb5f 666 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 667 echo "DONE"; \
8f74418b 668 fi; \
f89ccb5f 669 if [ -n "$filelist_debug" ]; then \
4d5370ac 670 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 671 chmod u+w $filelist_debug; \
f89ccb5f 672 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 673 echo "DONE"; \
9f0d4f36 674 fi; \
53d5af13 675fi; }; __spec_install_post_strip } } }
3241033b 676
fc5d7e20 677#-----------------------------------------------------------------
4d31c695 678# remove all RPATH/RUNPATH from executable binaries and shared object files
fc5d7e20 679#
680# Requires: find, awk, cut, xargs, chrpath, uname
681#
a2ad2754
JB
682# Special macros which affect this process
683#%no_install_post_chrpath 1 # disable chrpath at all
684#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
685#
fc5d7e20 686%__spec_install_post_chrpath {%{!?debug: \
53d5af13 687%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
f58a5195 688%{!?debug:set +x;} \
9f0d4f36 689if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 690 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 691 if [ -n "$files" ]; then \
d5517264 692 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 693 fi; \
98a06bad 694 if [ -n "$objs" ]; then \
4d31c695 695 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
696 echo "$objs" | \
697 while read file; do \
698 rpath= ; \
699 chmod u+w "$file"; \
d8ba59fb 700 for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
701 case $dir in \
702 '$ORIGIN' ) \
703 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
704 else rpath="$rpath:$dir" ; fi ; \
705 continue ; \
706 ;; \
707 esac ; \
f9abaddb
AM
708 newdir=$(readlink -m "$dir"); \
709 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
710 case $dir in \
711 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
712 echo "remove-rpath: $dir in $file"; \
713 ;; \
714 * ) \
715 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
716 else rpath="$rpath:$dir" ; fi ; \
717 ;; \
718 esac ; \
719 done ; \
720 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
721 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
722 done; \
723 fi; \
53d5af13 724fi; }; __spec_install_post_chrpath } } }
3241033b 725
611a25d5 726# vim: "
727
d366d7e0
AM
728#-----------------------------------------------------------------
729# Find all shared object files with unresolved symbols. Warn
730# and terminate if any found (termination can be turned off by define).
731#%no_install_post_check_so 1
ff8c88f6 732#%skip_post_check_so libwithunresolvedok.so.*
e067aec9 733#
734# NOTE: define skip_post_check_so only if such library really requires
735# unresolved symbols and always leave a comment why it is required:
736# # executable provides symbols foo, bar for those libraries:
737# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
738#
d366d7e0 739%__spec_install_post_check_so { \
229037b6 740__spec_install_post_check_so() { \
f58a5195 741%{!?debug:set +x;} \
229037b6
ER
742 fail=0; \
743 printf "Searching for shared objects with unresolved symbols..."; \
744 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
bca5d19b 745 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; skip["_ZSt15__once_callable"]=1; skip["_ZSt11__once_call"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
229037b6
ER
746 done ; \
747 echo " DONE"; \
748 %{!?no_install_post_check_so:return $fail;} \
d366d7e0
AM
749}; __spec_install_post_check_so }}
750
56dfec19
JR
751#-----------------------------------------------------------------
752# Find all ELF files with executable stac. Warn and terminate if any found
753# (termination can be turned off by define).
73c33fdc 754# Details: https://wiki.gentoo.org/wiki/Hardened/GNU_stack_quickstart
56dfec19
JR
755#%no_install_post_check_stackexec 1
756#%skip_post_check_stackexec libwithexecstackok.so.*
757#
758# NOTE: define skip_post_check_stackexec only if such program or library
759# really requires executable stack and always leave a comment why
760# it is required:
761# # Programs full of nested functions that cannot be fixed
762# %define skip_post_check_execstack /bin/foo libwithexecstack.so.*
763#
764%__spec_install_post_check_execstack { \
765__spec_install_post_check_execstack() { \
766%{!?debug:set +x;} \
767 fail=0; \
768 printf "Searching for ELF programs with executable stack..."; \
769 for f in $(find $RPM_BUILD_ROOT -type f -print) ; do \
770 LC_ALL=C readelf -lW $f 2>/dev/null | \
771 LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; } /GNU_STACK/ { if ($7 ~ "E") { found=1 } } END { if (found) { print "\nExecutable stack found in: " file; %{?skip_post_check_execstack:split("%{skip_post_check_execstack}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "File marked with skip_post_check_execstack, ignoring errors.\n"; exit(0); } } } exit(1); } }' || fail=1 ; \
772 done ; \
773 echo " DONE"; \
774 %{!?no_install_post_check_execstack:return $fail;} \
775}; __spec_install_post_check_execstack }}
776
918e69bf
JR
777#-----------------------------------------------------------------
778# Verify that for each directory under /var/run package contains
779# tmpfiles.d configuration. Warn and terminate build if config is
780# missing.
781#
782#%no_install_post_check_tmpfiles 1
783#
784%__spec_install_post_check_tmpfiles { \
785__spec_install_post_check_tmpfiles() { \
786%{!?debug:set +x;} \
787 fail=0; \
788 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
789 for d in $RPM_BUILD_ROOT/var/run/*; do \
790 [ -d "$d" ] || continue; \
791 d=${d##$RPM_BUILD_ROOT}; \
0b39f25d 792 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
3303369c 793 echo "No tmpfiles configuration for '$d'";\
918e69bf
JR
794 fail=1 ; \
795 fi \
796 done ; \
797 echo " DONE"; \
798 %{!?no_install_post_check_tmpfiles:return $fail;} \
799}; __spec_install_post_check_tmpfiles }}
800
02bc4ed5
JK
801#-----------------------------------------------------------------
802# Verify that scripts have reasonable shebangs
968c9e06 803# Test spec: see "test/spec_install_post_check_shebangs" branch on packages/test.spec
02bc4ed5
JK
804#
805#%no_install_post_check_shebangs 1
806#
807%__spec_install_post_check_shebangs { \
808__spec_install_post_check_shebangs() { \
809%{!?debug:set +x;} \
810 fail=0; \
811 echo "Checking script shebangs..."; \
c53b26d7 812 for f in $(find $RPM_BUILD_ROOT -type f -perm -500 -print); do \
b5868bc3
JK
813 shebang="$(sed -e'1s/#! *\(.*\)/\1/;t;d;q' "$f")" ; \
814 f="${f##$RPM_BUILD_ROOT}"; \
02bc4ed5 815 case "$shebang" in \
38dac5ff 816 "%{__python}"|"%{__python3}"|"%{__python} "*|"%{__python3} "* \
c8444a8b
JK
817 |"/usr/bin/python%{py_ver}"|"/usr/bin/python%{py_ver} "* \
818 |"/usr/bin/python%{py3_ver}"|"/usr/bin/python%{py3_ver} "*) \
02bc4ed5
JK
819 ;; \
820 "/usr/bin/env python"*|"/usr/bin/python"|"/usr/bin/python "*) \
821 echo "$f starts with '#!$shebang', should be '#!%{__python}' or '#!%{__python3}'" >&2;\
822 fail=1 ; \
823 ;; \
824 "/usr/bin/env "*) \
825 echo "$f starts with '#!$shebang', should be explicit interpreter path" >&2;\
826 fail=1 ; \
827 ;; \
828 *) ;;\
829 esac ; \
830 done ; \
831 echo " DONE" ; \
c53b26d7
AM
832 %{!?no_install_post_check_shebangs:return $fail;} \
833}; __spec_install_post_check_shebangs }}
02bc4ed5 834
ef64802f
ER
835# Remove common Perl files we don't package
836%__spec_install_post_perl_clean {\
837%{!?no_install_post_perl_clean: \
838%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
839} }
840
b541a244
JB
841# Helpers to specify SONAME depdendencies, e.g.:
842# Requires: %{_soname_prov libfoo.so.1}
843# Requires: %{_soname_prov libfoo.so.1(SOME_SYMVER)}
844#
845# BuildRequires: rpmbuild(macros) >= 1.721
846#
847%_soname_tag %(echo %{_lib} | sed -e 's/^lib//' -e 's/^\\(.\\+\\)$/(\\1bit)/')
848%_soname_prov() %(echo "%{1}()%{_soname_tag}" | sed -e 's/^\\([^(]*([^)]\\+)\\)()%{_soname_tag}$/\\1%{_soname_tag}/;s/()$//')
849
83094b62 850#-----------------------------------------------------------------
0e4cb4dd 851# Update GConf2 schemas
83094b62 852#
853# Requires: GConf2
854#
46885239 855%gconf_schema_install() \
307ac6c9
ER
856 umask 022; \
857 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
858 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 859%{nil}
46885239 860
861%gconf_schema_uninstall() \
24336a54 862if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 863 umask 022; \
24336a54
ER
864 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
865 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 866fi; \
f93109a0 867%{nil}
868
869#-----------------------------------------------------------------
870# Update desktop MIME database
c0a4caa0 871# requires: desktop-file-utils
c3bcd10e 872%update_desktop_database() {{ \
f93109a0 873 umask 022; \
fb59e475 874 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
875};} \
876%{nil}
f93109a0 877
c3bcd10e
ER
878%update_desktop_database_post %update_desktop_database
879
880%update_desktop_database_postun() {{ \
f27cf2fd 881if [ "$1" = "0" ]; then \
c00bf95c 882 %update_desktop_database \
f27cf2fd 883fi; \
c00bf95c
MB
884};} \
885%{nil}
f93109a0 886
fb59e475 887#-----------------------------------------------------------------
888# Update shared MIME info database
889# requires: shared-mime-info
35d0c9a6
TP
890# Note: https://bugs.freedesktop.org/show_bug.cgi?id=70366#c19
891# https://bugzilla.redhat.com/show_bug.cgi?id=1052173
892# TODO: if you want this running with fdatasync(), make sure it's:
893# 1. announcing ~minute delay by echoing appropriate message,
894# 2. running only once after rpm transaction.
fb59e475 895#
c3bcd10e 896%update_mime_database() {{ \
fb59e475 897 umask 022; \
c8c0d5f5 898 PKGSYSTEM_ENABLE_FSYNC=0 \
fb59e475 899 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
900};} \
901%{nil}
fb59e475 902
903#-----------------------------------------------------------------
904# Update icon cache
3303369c
TP
905# BuildRequires: rpmbuild(macros) >= 1.596
906# Requires: hicolor-icon-theme
fb59e475 907#
c3bcd10e 908%update_icon_cache() {{ \
9639d726
ER
909 %{!?1:%{error:%{0}: Required theme name missing}} \
910 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
911 umask 022; \
912 touch --no-create %{_iconsdir}/%1; \
913 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
914 fi; \
c00bf95c
MB
915};} \
916%{nil}
fb59e475 917
f93109a0 918#-----------------------------------------------------------------
919# Update scrollkeeper database
920# requires: scrollkeeper
921#
922%scrollkeeper_update_post() \
f93109a0 923 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 924%{nil}
f93109a0 925
926%scrollkeeper_update_postun() \
f27cf2fd 927if [ "$1" = "0" ]; then \
f93109a0 928 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 929fi; \
f93109a0 930%{nil}
931
c9704b95
MB
932#-----------------------------------------------------------------
933# Compile GSettings schemas
934# requires: glib2 >= 1:2.26.0
935#
936%glib_compile_schemas() {{ \
937 umask 022; \
938 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
939};} \
940%{nil}
941
9c404149
AM
942#-----------------------------------------------------------------
943# post %install sequence:
944# - autodeps exceptions
945# - compress all man and info pages,
946# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 947# - compress kernel modules if any
9c404149
AM
948
949###################################################################
950# Requires/Provides automation
3e202b06 951# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 952#
2892b5df
JB
953%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
954%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
2892b5df 955%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
da8e49db
JB
956%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov) \
957 %{?_noautoprov: %{_noautoprov}} \
958 %{?_noautoprov_java: %{__noauto_regexp_helper -p java %{_noautoprov_java}}} \
959 %{?_noautoprov_mono: %{__noauto_regexp_helper -p mono %{_noautoprov_mono}}} \
960 %{?_noautoprov_pear: %{__noauto_regexp_helper -p pear %{_noautoprov_pear}}} \
961 %{?_noautoprov_perl: %{__noauto_regexp_helper -p perl %{_noautoprov_perl}}} \
962 %{?_noautoprov_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoprov_pyegg}}} \
963 %{?_noautoprov_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoprov_py3egg}}} \
964 %{nil}
0a9bb974
ER
965%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
966 %{?_noautoreq: %{_noautoreq}} \
4e311fe4 967 %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
4dc4b33c 968 %{?_noautoreq_mono: %{__noauto_regexp_helper -p mono %{_noautoreq_mono}}} \
0a9bb974
ER
969 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
970 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
e7053164
JR
971 %{?_noautoreq_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoreq_pyegg}}} \
972 %{?_noautoreq_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoreq_py3egg}}} \
0a9bb974
ER
973 %{nil}
974
975# helper for wrapping _noautoreq between perl() or pear()
976# Author: Elan Ruusamäe <glen@pld-linux.org>
977# Usage:
978# BuildRequires: rpmbuild(macros) >= 1.654
979# %define _noautoreq_pear Excluded.php PEAR/Something.php
980# %define _noautoreq_perl Apache::.*
42bc86d6
ER
981# BuildRequires: rpmbuild(macros) >= 1.672
982# %define _noautoreq_java ClassDataVersion
90a48f11
ER
983# BuildRequires: rpmbuild(macros) >= 1.709
984# %define _noautoreq_pyegg argparse
985# %define _noautoreq_py3egg backports.ssl-match-hostname ipaddress
4e311fe4
JB
986# BuildRequires: rpmbuild(macros) >= 1.730
987# %define _noautoreq_mono Gendarme.Framework
da8e49db
JB
988# BuildRequires: rpmbuild(macros) >= 1.737
989# %define _noautoprov_java Class
990# %define _noautoprov_mono Excluded.Provide
991# %define _noautoprov_pear Excluded.php
992# %define _noautoprov_perl Excluded::Module
993# %define _noautoprov_pyegg excluded
994# %define _noautoprov_py3egg excluded3
4b369e1f
ER
995#
996%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}%{__qchar}(%%s%{__qchar}) ", $1)}')
997# detect quote character runtime
998%__qchar_4 \\\\%{nil}
999%__qchar_5 \\\\\\%{nil}
1000%__qchar %{expand:%%global __qchar %%__qchar_%(echo %{_rpmversion} | cut -c1)}%__qchar
c94807f3 1001
338726a6
JB
1002#%_noautocompressdoc %{nil}
1003#
8f74418b
MM
1004%_missing_doc_files_terminate_build 1%{nil}
1005%_unpackaged_files_terminate_build %{nil}
8781dc74 1006# (X)emacs support
3303369c 1007%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
1008%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
1009%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 1010
02b58f60
JK
1011%__perl_provides %{nil}
1012%__perl_requires %{nil}
fa3497cd 1013%__mono_provides %{nil}
1014%__mono_requires %{nil}
25043cd4
AF
1015
1016# Perl specific macro definitions.
c94807f3
ER
1017%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
1018%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
1019%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
1020%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
1021%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
1022%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 1023
578e9248 1024# X.org helper macros
434ab5a2
ER
1025%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
1026%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
1027
c94807f3
ER
1028%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
1029%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
1030%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
1031%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
1032%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 1033# vim: '
578e9248 1034
434ab5a2 1035%requires_xorg_xserver_extension \
97486460
AM
1036%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1037%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1038%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
1039%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
1040%{nil}
1041
1042%requires_xorg_xserver_xinput \
97486460
AM
1043%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1044%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1045%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
1046%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
1047%{nil}
1048
1049%requires_xorg_xserver_font \
97486460
AM
1050%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1051%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1052%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
1053%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
1054%{nil}
1055
1056%requires_xorg_xserver_videodrv \
97486460
AM
1057%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1058%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1059%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
1060%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 1061%{nil}
578e9248 1062
15d7cc4a
ER
1063# TCL specific macro definitions.
1064# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
1065%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
1066%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1067%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1068
25043cd4
AF
1069# Python specific macro definitions.
1070# python main version
2383a9da 1071%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
1072
1073# directories
2383a9da 1074%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 1075%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 1076%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 1077%py_incdir /usr/include/python%{py_ver}
7ccf7643 1078%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 1079%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 1080%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
1081
1082# pure python modules compilation
3241033b 1083%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 1084
3241033b 1085%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
1086
1087# Software written in Python language require Python with main version
e63cd81d 1088%pyrequires_eq() Requires: %1
25043cd4 1089
4bf34b55
AF
1090# Python 3.x
1091# python main version
f5b9833d 1092%__python3 /usr/bin/python3
4bf34b55
AF
1093%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1094
1095# directories
1096%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
04db4b29 1097%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
48888623
JK
1098%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
1099%py3_sitedir %{py3_libdir}/site-packages
1100%py3_sitescriptdir %{py3_prefix}/share/python%{py3_ver}/site-packages
4bf34b55
AF
1101%py3_dyndir %{py3_libdir}/lib-dynload
1102
1103# pure python modules compilation
1104%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1105
1106%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1107
1719784f 1108%py_build { \
54b2501c
JK
1109 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1110 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1111 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1112 %{?__cc:CC="%{__cc}"; export CC;} \
1113 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1114 %{__python} setup.py \
709093b6 1115 build --build-base=build-2 \
54b2501c
JK
1116}
1117
1719784f
ER
1118# "shrink" filter to keep this macro without newlines,
1119# so it could be used as make arguments
1120%py_install_opts() %{shrink: \
1121 --prefix=%{_prefix} \
1122 --install-purelib=%{py_sitescriptdir} \
1123 --install-platlib=%{py_sitedir} \
1124 --optimize=2 \
1125}
1126
1127%py_install { \
54b2501c
JK
1128 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1129 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1130 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1131 %{?__cc:CC="%{__cc}"; export CC;} \
1132 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1133 %{__python} setup.py \
709093b6 1134 build --build-base=build-2 \
54b2501c 1135 install --skip-build \
1719784f 1136 %{py_install_opts} \
54b2501c
JK
1137 --root=$RPM_BUILD_ROOT \
1138}
1139
1719784f 1140%py3_build { \
54b2501c
JK
1141 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1142 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1143 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1144 %{?__cc:CC="%{__cc}"; export CC;} \
1145 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
709093b6 1146 %{__python3} setup.py build --build-base=build-3 \
54b2501c
JK
1147}
1148
1719784f
ER
1149# "shrink" filter to keep this macro without newlines,
1150# so it could be used as make arguments
1151%py3_install_opts() %{shrink: \
1152 --prefix=%{_prefix} \
1153 --install-purelib=%{py3_sitescriptdir} \
1154 --install-platlib=%{py3_sitedir} \
1155 --optimize=2 \
1156}
1157
1158%py3_install { \
54b2501c
JK
1159 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1160 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1161 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1162 %{?__cc:CC="%{__cc}"; export CC;} \
1163 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1164 %{__python3} setup.py \
709093b6 1165 build --build-base=build-3 \
54b2501c 1166 install --skip-build \
1719784f 1167 %{py3_install_opts} \
54b2501c
JK
1168 --root=$RPM_BUILD_ROOT \
1169}
1170
09961759
ER
1171# node.js libdir
1172# Requirements:
1173# BuildRequires: rpmbuild(macros) >= 1.634
1174%nodejs_libdir /usr/lib/node_modules
57241c0e 1175
1316894b 1176# bash-completion 2.0 completions dir
a4e1cc18 1177# Requirements:
ea132ee6 1178# BuildRequires: rpmbuild(macros) >= 1.673
bb45f0fe 1179# Requires: bash-completion >= 2.0
1316894b 1180%bash_compdir /usr/share/bash-completion/completions
a4e1cc18 1181
d46b35f5
ER
1182# fish completions dir
1183# Requirements:
1184# BuildRequires: rpmbuild(macros) >= 1.720
1185%fish_compdir /usr/share/fish/vendor_completions.d
1186
ea132ee6
ER
1187# zsh completions dir
1188# Requirements:
1189# BuildRequires: rpmbuild(macros) >= 1.719
1190%zsh_compdir /usr/share/zsh/site-functions
1191
f12c2314 1192# Hardlink binary identical .pyc and .pyo files
f12c2314 1193%__spec_install_post_py_hardlink {\
53d5af13 1194%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f58a5195 1195%{!?debug:set +x;} \
5ed24c89 1196local a b c=0 t=0 pyc=%{tmpdir}/%{name}-%{version}-%{release}__rpm_pyc; \
f35a1d62 1197if [ -d "$RPM_BUILD_ROOT" ]; then \
5ed24c89 1198 find "$RPM_BUILD_ROOT" -name '*.pyc' > $pyc; \
f35a1d62
ER
1199 while read a; do \
1200 b="${a%.pyc}.pyo"; \
1201 if cmp -s "$a" "$b"; then \
1202 ln -f "$a" "$b"; \
1203 c=$((c + 1)); \
1204 fi; \
1205 t=$((t + 1)); \
5ed24c89 1206 done < $pyc; \
f35a1d62 1207 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
5ed24c89 1208 rm -f $pyc; \
f35a1d62 1209fi; \
53d5af13 1210}; __spec_install_post_py_hardlink } }
f12c2314 1211
6454da06
ER
1212# Remove Python 2.x sources,
1213# PLD Linux policy is to package only compiled .py[co] for Python 2.x libraries.
1214# Author: Elan Ruusamäe <glen@pld-linux.org>
1215#
1216# Usage:
1217# %py_postclean /usr/share/extra -x keepme.py,keeptoo.py
1218# Options:
93ecebe3 1219# -x - comma separated of file basenames to preserve (rpmbuild(macros) >= 1.658)
6454da06
ER
1220# ARGS - extra directories to clean for .py sources
1221#
6d2f17f3
ER
1222# BuildRequires: rpmbuild(macros) >= 1.189
1223#
6454da06 1224%py_postclean(x:) \
0f82e280 1225for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
6454da06 1226 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 %{-x:| grep -ZzvE '/(%(echo '%{-x*}' | tr ',' '|'))$'} | xargs -0r -l512 rm;\
4bf34b55
AF
1227done \
1228%{nil}
1229
0fc5cff8 1230# depmod macro
1231%depmod() { \
f6148427 1232umask 022; \
0fc5cff8 1233if [ -e /boot/System.map-%1 ]; then \
3241033b 1234 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 1235else \
3241033b
ER
1236 if [ -e /boot/System.map ]; then \
1237 /sbin/depmod -a -F /boot/System.map %1; \
1238 else \
1239 /sbin/depmod -a %1; \
1240 fi \
0fc5cff8 1241fi; \
1242}
1243
2afc6e64 1244# XMMS specific macros
c94807f3
ER
1245%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1246%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1247%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1248%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1249%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1250%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1251%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1252%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1253%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1254%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1255
848c0d68 1256# user/group checking macros
1257#
1258# Usage:
1259# %userremove myuser
1260#
1261%userremove /usr/lib/rpm/user_group.sh user del
1262%groupremove /usr/lib/rpm/user_group.sh group del
1263#
1264# Usage:
1265# if %usertestrm myuser; then
1266# /usr/sbin/userdel -r myuser
1267# Note:
1268# use these macros only if you need to call userdel/groupdel with
1269# a non-standard option or take an extra action; otherwise use the
1270# %userremove/%groupremove macros
1271#
1272%usertestrm /usr/lib/rpm/user_group.sh user testrm
1273%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1274# user group membership management macros
1275#
1276# Usage:
efbc7726 1277# %addusertogroup [-q] myuser agroup
08d9b1f6 1278#
efbc7726
ER
1279# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1280#
1281# Requirements:
1282# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1283%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1284%{nil}
72fcfcb3 1285
1286# banner support (useful in {pre,post}{,un} and triggers)
1287#
1288# Usage:
908f5713 1289# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
72fcfcb3 1290# the banner text, the banner text
aa41c920
ER
1291# the banner text, and following line
1292#EOF
1293# You can use any form of here-document, <<'EOF' <<-EOT will do.
1294# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1295#
3303369c
TP
1296# -a - append to the banner
1297# -e - send to stderr instead of stdout
1298# -n - don't show banner (overrides -t)
1299# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1300# -o - show only once, i.e when package is installed for the first time
276a7b45
ER
1301#
1302# Tests:
1303# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
908f5713
ER
1304# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1305# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
276a7b45 1306# rpm -E 'date | %banner -e banner' > m; sh -x m
908f5713 1307# rpm -E 'date | %banner -o -e banner' > m; sh -x m
276a7b45 1308#
908f5713 1309%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1b334fe4 1310RPM_SCRIPTVERBOSITY=5 \
1311[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1312if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1313 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1314else \
a8b9562a 1315 CMD="cat%{-e: >&2}" \
1b334fe4 1316fi \
908f5713 1317eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
276a7b45 1318%{nil}
628754cb 1319
990bd03f 1320# useradd/groupadd macros
4c73bc69 1321# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1322#
1323# Usage:
1324# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1325# [-g initial_group] [-G group[,...]] login
1326#
1327# -u uid. REQUIRED
1328# -g gid/group. REQUIRED
1329# -s defaults to /bin/false
1330# -d defaults to /usr/share/empty
1331# -c No default
1332# -r is accepted but ignored (it's always set)
6bd4c218 1333# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1334# rpm specific flags
1335# -P package name. defaults to %{name}
1336#
90627280 1337%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1338%{!-u:%{error:useradd: Required argument -u missing}} \
1339%{!-g:%{error:useradd: Required argument -g missing}} \
1340%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1341if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1342 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1343 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1344 exit 1 \
1345 fi \
1346else \
1347 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1348 /usr/sbin/useradd \\\
b5a7d552 1349 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1350 -u %{-u*} \\\
1351 -r \\\
1352 -d %{-d*}%{!-d:/usr/share/empty} \\\
1353 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1354 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1355 -g %{-g*} \\\
1356 %{-M} \\\
1357 %{-G:-G %{-G*}} \\\
1aac682a 1358 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1359 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1360fi;
611a25d5 1361# vim: "
90627280 1362
90627280
ER
1363# Usage:
1364# %groupadd [-P package] [-g gid] group
1365#
1366# -g gid. REQUIRED
1367#
1368# Sample:
1369# %groupadd -P %{name}-base -g %{gid} %{name}
1370
1371%groupadd(g:P:rfo) \
9ba02ba9
ER
1372%{!-g:%{error:groupadd: Required argument -g missing}} \
1373%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1374if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1375 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1376 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1377 exit 1 \
1378 fi \
1379else \
1380 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1381 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1382 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1383fi;
7cb77741 1384
7c50f037 1385# webapp macros
4c73bc69 1386# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1387#
1388# The config is installed/removed inside trigger, this means that you can any
1389# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1390# updated. if you don't need the config for various reason for specific
35663282
ER
1391# webserver, just remove the symlink from config directory using webapp
1392# program. the trigger will not recreate the symlink on upgrades. In other
1393# words the config is linked to webserver config directory on first install of
1394# PACKAGE or WEBSERVER.
1395#
7c50f037
ER
1396# Add package's webserver config to webserver webapps dir.
1397# Usage:
aea687a7 1398# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1399#
aea687a7 1400%webapp_register(f) \
35663282 1401%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
ee3bbe4c 1402if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]); then\
35663282
ER
1403 /usr/sbin/webapp register %1 %2\
1404fi\
694a8f2e 1405# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1406if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1407 %{expand:%service -q %%1 reload}\
35663282
ER
1408fi\
1409%{nil}
1410
1411# Remove package's config from webserver webapps dir.
35663282 1412# Usage:
531c0efc
ER
1413# %webapp_register [-f] WEBSERVER WEBAPP
1414%webapp_unregister(f) \
35663282
ER
1415%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1416# remove link if either of the packages are gone \
ee3bbe4c 1417if [ -n "%{-f:1}" ] || ([ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]); then \
df979130 1418 /usr/sbin/webapp unregister %1 %2\
16897aea 1419 %{expand:%service -q %%1 reload}\
35663282
ER
1420fi \
1421%{nil}
1422
462b26fa 1423# service macro.
4c73bc69 1424# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1425#
1426# calls usual service restart on package %post, but skips the restart if
1427# administrator has disabled automatic service restarts in either global
1428# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
2aa55885
TP
1429# NOTE: systemd_booted machines do not print
1430# Run "{command}" to restart {service}.
1431# message for packages without native systemd unit (not here, no %systemd_post).
462b26fa 1432#
462b26fa 1433# Usage:
7377b5ca 1434# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1435#
a0bbe604 1436# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1437# -n NOOP mode, do not actually restart service
462b26fa 1438#
7377b5ca
ER
1439# Requirements:
1440# BuildRequires: rpmbuild(macros) >= 1.268
1441# Requires: rc-scripts
1442# -n option:
1443# BuildRequires: rpmbuild(macros) >= 1.450
207c9ca4 1444%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62 1445
0d5dd00c 1446# Register OpenLDAP schema.
4c73bc69 1447# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1448#
1449# Usage:
1450# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1451#
1452# -d specify dependant schemas, separated by comma
1453#
1454%openldap_schema_register(d:) \
1455for schema in %*; do \
1456 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1457 %{__sed} -i -e " \
1458 /^include.*local.schema/{ \
1459 iinclude\\t $schema\
1460 } \
1461 " /etc/openldap/slapd.conf \
1462 fi \
1463done \
1464# enable dependant schemas \
1465if [ "%{-d*}" ]; then \
1466 %{__sed} -i -e ' \
1467 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1468 s/^#// \
1469 }' /etc/openldap/slapd.conf \
1470fi \
1471%{nil}
1472
1473# Unregister OpenLDAP schema.
4c73bc69 1474# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1475#
1476# Usage:
1477# %%openldap_schema_unregister %{schemadir}/horde.schema
1478#
1479%openldap_schema_unregister() \
1480for schema in %*; do \
1481 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1482 %{__sed} -i -e " \
1483 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1484 # for symmetry it would be nice if we disable enabled schemas in post, \
1485 # but we really can not do that, it would break something else. \
1486 " /etc/openldap/slapd.conf \
1487 fi \
1488done \
1489%{nil}
1490
b0bc2936 1491%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1492
fa65356c 1493# patchset macros
4b7f0e84
ER
1494# generate SourceX urls from range START STOP
1495# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1496# The sources start from 10000
1497#
4c73bc69 1498# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1499#
1500# Usage:
1501# %patchset_source -f <seq(1) format> <start> [<end>]
1502# %patchset_patch <start> [<end>]
fa65356c
ER
1503# If <end> is omited, it is assumed to be <start>.
1504#
1505# For example in preamble:
1506# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1507# and in %prep:
1508# %patchset_patch 33 44
4b7f0e84
ER
1509#
1510# Using sources list:
edd07077 1511# BuildRequires: rpmbuild(macros) >= 1.426
4b7f0e84
ER
1512# %patchset_source -f <url> -s <filelist>
1513# %patchset_patch -s <filelist>
1514# For example (ncurses):
edd07077 1515# BuildRequires: rpmbuild(macros) >= 1.683
4b7f0e84
ER
1516# %patchset_source -f ftp://dickey.his.com/ncurses/%{basever}/ -s sources
1517# %patchset_patch -s sources -p1
1518#
1519
1520%patchset_source(f:b:s:) %(
1521 base=%{-b*}%{!-b*:10000}
1522%{-s:
1523 baseurl='%{-f*}'
1524 filelist='%{-s*}'
1525 i=$base
1526 while read checksum file; do
1527 printf "Patch%d: %s%s\\n" $i "$baseurl" "$file"
1528 i=$((i+1))
1529 done < $filelist
1530}
1531%{!-s:
962f9ecf
ER
1532 start=$(expr $base + %1);
1533 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1534 # we need to call seq twice as it doesn't allow two formats
1535 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1536 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1537 paste %{tmpdir}/__ps{1,2};
1538 rm -f %{tmpdir}/__ps{1,2};
4b7f0e84 1539}
962f9ecf
ER
1540) \
1541%{nil}
fa65356c
ER
1542
1543# apply sources from %patchset_source
1544# -p specify -pX for %patch line
1545# -b base offset: defaults to 10000
4b7f0e84
ER
1546# -s filelist to read files from
1547%patchset_patch(f:p:b:s:) %(
1548 base=%{-b*}%{!-b*:10000}
1549 patchlevel=%{-p*:-p%{-p*}}
1550%{-s:
1551 filelist='%{-s*}'
1552 i=$base
1553 while read checksum file; do
1554 printf "patch%d %s\\n" $i "$patchlevel" | sed -e s,^,%%,
1555 i=$((i+1))
1556 done < $filelist
1557}
1558%{!-s:
962f9ecf
ER
1559 start=$(expr $base + %1);
1560 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db 1561 echo ": patchset_patch %1%{?2: to %2}";
4b7f0e84
ER
1562 seq -f "patch%g $patchlevel" $start $end | sed -e s,^,%%,;
1563}
962f9ecf
ER
1564) \
1565%{nil}
fa65356c 1566
c0d21ccc
ER
1567# return EXPANDED source url N from current spec
1568%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1569
5730b44b 1570# browser plugins v2
4c73bc69 1571# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1572#
1573# Usage:
1574# %browser_plugins_add_browser <name> -p <plugindir>
1575#
1576# <name> (required) -- name of the browser. usually %{name}.
1577# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1578# -b -- default blacklists
1579# -a <arch> override arch
5730b44b
ER
1580#
1581# Example:
1582# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1583
1584%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1585%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1586%update_browser_plugins /usr/sbin/update-browser-plugins || :
1587
02ebf70f 1588%browser_plugins_add_browser(p:b:a:) \
9efd458e 1589 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1590 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1591 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1592 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1593 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1594 %{-b:cat >> $blacklist_file %{-b*}} \
1595%{nil}
1596
ad17b654
ER
1597# Helper for LUA.
1598# split string separated by space into quoted list
1599#
4c73bc69 1600# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1601#
1602# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1603%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1604
1605# adjust /etc/shells by adding and removing shells from there
4c73bc69 1606# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1607#
1608# Usage:
d9b789d9
ER
1609# %post -p <lua>
1610# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1611#
d9b789d9
ER
1612# %preun -p <lua>
1613# if arg[2] == 0 then
1614# %lua_remove_etc_shells /bin/bash /bin/rbash
1615# end
7377b5ca
ER
1616#
1617# Requirements:
d9b789d9
ER
1618# BuildRequires: rpmbuild(macros) >= 1.462
1619#
ad17b654 1620
d9b789d9 1621%lua_add_etc_shells() \
ad17b654
ER
1622t = {}\
1623f = io.open("/etc/shells", "r")\
1624if f then\
1625 for l in f:lines() do t[l]=l; end\
1626 f:close()\
1627end\
1628for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1629 if not t[s] then\
b8c0bc18 1630 print("Adding "..s.." to /etc/shells")\
da13045e 1631 f = io.open("/etc/shells", "a")\
b7e89f70
AM
1632 if f then\
1633 f:write(s.."\\n")\
1634 f:close()\
0ecc917f 1635 end\
ad17b654
ER
1636 end\
1637end\
1638%{nil}
1639
d9b789d9
ER
1640%lua_remove_etc_shells() \
1641t = {}\
1642f = io.open("/etc/shells", "r")\
1643if f then\
1644 for l in f:lines() do t[l]=l; end\
1645 f:close()\
1646end\
1647for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1648 print("Removing "..l.." from /etc/shells")\
1649 t[l] = nil\
1650end\
1651s=""\
1652for _, l in pairs(t) do\
1653 s=s..l.."\\n"\
1654end\
d2c9cab9
AM
1655f = io.open("/etc/shells", "w")\
1656if f then\
a449721f 1657 f:write(s)\
d2c9cab9
AM
1658 f:close()\
1659end\
d9b789d9
ER
1660%{nil}
1661
1662# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1663#
1664# Author: Elan Ruusamäe <glen@pld-linux.org>
1665#
1666# Usage:
1667# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1668# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1669#
1670# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1671#
1672# Requirements:
1673# BuildRequires: rpmbuild(macros) >= 1.429
1674#
1675%add_etc_shells(p) %{-p:<lua>}\
1676%{expand:%%lua_add_etc_shells %*}\
1677%{nil}
1678
ad17b654 1679%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1680%{-p:if arg[2] == 0 then}\
d9b789d9 1681%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1682%{-p:end} \
ad17b654
ER
1683%{nil}
1684
75bd6249
ER
1685# Check syntax for Python files
1686#
1687# Author: Elan Ruusamäe <glen@pld-linux.org>
1688# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1689#
1690# Usage:
1691# %py_lint src
1692#
1693# Requirements:
1694# BuildRequires: python
4334275f 1695# BuildRequires: rpmbuild(macros) >= 1.602
75bd6249
ER
1696
1697%py_lint() \
1698__py_lint() { \
f58a5195 1699%{!?debug:set +x;} \
75bd6249
ER
1700find "$@" -type f -name '*.py' | python -c ' \
1701import sys \
1702import compiler \
1703\
5ba658ad 1704found = err = 0\
75bd6249 1705for f in sys.stdin: \
1b3501f3 1706 fd = open(f.rstrip()) \
75bd6249
ER
1707 c = fd.read() \
1708 fd.close() \
1b3501f3 1709 found = found + 1 \
75bd6249
ER
1710 try: \
1711 compiler.parse(c) \
1712 except SyntaxError, e: \
1b3501f3 1713 print "py_lint: %s: %s" % (f.rstrip(), e) \
75bd6249
ER
1714 err = err + 1\
1715\
5ba658ad
ER
1716if not found:\
1717 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
1718 sys.exit(1) \
1719elif err: \
75bd6249
ER
1720 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1721 sys.exit(1) \
1722else: \
1b3501f3 1723 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
75bd6249
ER
1724' \
1725}; __py_lint %* \
1726%{nil}
1727
f602e4a0 1728# Undos files
1729#
1730# Author: Paweł Zuzelski <pawelz@pld-linux.org>
0217c63b 1731# Author: Elan Ruusamäe <glen@pld-linux.org>
f602e4a0 1732#
1733# Usage:
1734# %undos list_of_files
0217c63b
ER
1735# %undos -f EXT[,EXT]
1736# %undos -i -f EXT[,EXT]
1737#
1738# -f EXT[,EXT] - find(1) files by extensions
1739# -i - case insensitive file search
1740#
1741# Example:
1742# Un-DOS all *.js, *.css files
1743# %undos -f js,css
1744# Un-DOS all *.js, *.JS files
1745# %undos -f js -i
1746# undos all Makefiles
1747# %{__find} -name Makefile | xargs %undos
f602e4a0 1748#
1749# Requirements:
1750# BuildRequires: sed >= 4.0
9878ac15 1751# BuildRequires: rpmbuild(macros) >= 1.674
f602e4a0 1752
0217c63b 1753# NB: make sure this macro stays on one line
81a64c94 1754# NB: make sure it includes newline escape
9878ac15 1755%undos(f:i) %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
81a64c94 1756%{nil}
f602e4a0 1757
2f79ae5a
ER
1758# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1759#
1760# Author: Elan Ruusamäe <glen@pld-linux.org>
1761#
1762# Usage:
1763# -a NAME -- add command named NAME
1764# -d NAME -- remove command named NAME
1765# -f FILE -- specify plugin configuration FILE to extract command definition from
1766#
1767# Sample:
1768# %triggerin -- nagios-nrpe
1769# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1770#
1771# %triggerun -- nagios-nrpe
1772# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1773#
1774# Requirements:
f236a3c2 1775# Requires: grep
1776# Requires: sed >= 4.0
210174e2 1777# BuildRequires: rpmbuild(macros) >= 1.685
2f79ae5a 1778%nagios_nrpe(a:d:c:f:) {\
210174e2
ER
1779 if %{__grep} -q '^include_dir=/etc/nagios/nrpe.d' /etc/nagios/nrpe.cfg && [ -d /etc/nagios/nrpe.d ]; then \
1780 file=/etc/nagios/nrpe.d/%{-a*}%{-d*}.cfg; \
1781 else \
1782 file=/etc/nagios/nrpe.cfg; \
1783 fi; \
1784 m=$(test -f $file && md5sum < $file); \
2f79ae5a 1785 %{-a:# on -a and config exists \
d7cee36f 1786 if [ -f /etc/nagios/nrpe.cfg ]; then \
210174e2
ER
1787 if [ ! -f $file ] || ! %{__grep} -q '^command\[%{-a*}\]' $file; then \
1788 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> $file; \
2f79ae5a
ER
1789 fi; \
1790 fi;} \
1791 %{-d:# on package remove, -d and config exists \
210174e2
ER
1792 if [ "$1" = "0" -a -f $file ]; then \
1793 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' $file; \
2f79ae5a 1794 fi;} \
210174e2 1795 if [ "$m" != "$(md5sum < $file)" ]; then \
d7cee36f
ER
1796 %service -q nrpe restart; \
1797 fi; \
2f79ae5a
ER
1798}%{nil}
1799
070aa9f4
ER
1800# Import or update Cacti template.
1801#
1802# Author: Elan Ruusamäe <glen@pld-linux.org>
1803#
1804# Usage:
1805# %cacti_import_template XMLFILE
1806# XMLFILE -- XML template to import
1807#
1808# Sample:
1809# %post
1810# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1811#
1812# Requires: cacti >= 0.8.7e-8
2e731582 1813# BuildRequires: rpmbuild(macros) >= 1.630
a42b19b3 1814# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
070aa9f4
ER
1815
1816%cacti_import_template() {\
a42b19b3
ER
1817v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
1818if [ "$v" != "1.0" ]; then \
1819 rra="--with-template-rras"; \
1820fi; \
1821/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
070aa9f4
ER
1822}%{nil}
1823
cdb82983
JK
1824# pre/post script for -upstart subpackages
1825#
1826# Author: Jacek Konieczny <jajcus@jajcus.net>
dc4639bc 1827# Author: Elan Ruusamäe <glen@pld-linux.org>
cdb82983
JK
1828#
1829# Usage:
1830# %upstart_post service_name
1831# %upstart_postun service_name
1832#
1833# Sample:
1834# %post upstart
1835# %upstart_post %{name}
1836#
1837# %postun upstart
1838# %upstart_postun %{name}
1839#
1840# Requirements:
dc4639bc 1841# BuildRequires: rpmbuild(macros) >= 1.690
cdb82983
JK
1842# Requires: rc-scripts >= 0.4.3
1843
1844# migrate from init script to upstart job
c4c1a53f 1845%upstart_post() \
dc4639bc 1846 if [ -x /sbin/initctl ] && [ -f /var/lock/subsys/%1 ]; then \
d70efb72
ER
1847 /sbin/service --no-upstart %1 stop \
1848 /sbin/service %1 start \
cefd17ae
ER
1849 fi \
1850%{nil}
cdb82983
JK
1851
1852# restart the job after upgrade or migrate to init script on removal
1853# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1854# at this point
c4c1a53f 1855%upstart_postun() \
d70efb72
ER
1856 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
1857 /sbin/initctl stop %1 >/dev/null 2>&1 \
1858 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
cefd17ae
ER
1859 fi \
1860%{nil}
cdb82983 1861
548c59c1 1862# Haskell Macros
3303369c 1863# BuildRequires: rpmbuild(macros) >= 1.608
548c59c1
ER
1864%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
1865
57241c0e
ER
1866# update /usr/lib*/ghc-*/package.conf.d/package.cache
1867# Requires: ghc
3303369c 1868# BuildRequires: rpmbuild(macros) >= 1.607
57241c0e 1869#
bd2fc6e5 1870%ghc_pkg_recache() {{ \
57241c0e 1871 umask 022; \
402e94f5 1872 [ ! -x /usr/bin/ghc-pkg ] || /usr/bin/ghc-pkg recache; \
57241c0e
ER
1873};} \
1874%{nil}
1875
575c6f8c 1876
22fb5d90 1877# pre/post script for packages supporting systemd units
575c6f8c 1878#
3303369c
TP
1879# Authors: Bartlomiej Zimon <uzi18@o2.pl>
1880# Jan Rękorajski <baggins@mimuw.edu.pl>
575c6f8c
BZ
1881#
1882# Usage:
cc9e4640 1883# %systemd_reload
55b1f314 1884# %systemd_service <unit command> service_name1.service service_name2.service
b3dce842 1885# %systemd_service_enable service_name1.service service_name2.service
48b92d3c
JR
1886# %systemd_service_disable service_name1.service service_name2.service
1887# %systemd_service_start service_name1.service service_name2.service
1888# %systemd_service_stop service_name1.service service_name2.service
1889# %systemd_service_restart service_name1.service service_name2.service
55b1f314 1890# %systemd_service_reload service_name1.service service_name2.service
48b92d3c 1891#
cc9e4640 1892# %systemd_post service_name1.service service_name2.service
22fb5d90 1893# %systemd_preun service_name1.service service_name2.service
b91bf642 1894# %systemd_trigger service_name1.service service_name2.service
575c6f8c
BZ
1895#
1896# Sample:
22fb5d90 1897# %post
cc9e4640 1898# %systemd_post %{name}.service
575c6f8c 1899#
22fb5d90 1900# %preun
cc9e4640 1901# %systemd_preun %{name}.service
575c6f8c 1902#
22fb5d90 1903# %postun
cc9e4640 1904# %systemd_reload
575c6f8c 1905#
22fb5d90
JR
1906# %triggerpostun -- %{name} < first-version-with-systemd-units
1907# %systemd_trigger %{name}.service
1908#
575c6f8c 1909# Requirements:
1aa882b6 1910# BuildRequires: rpmbuild(macros) >= 1.671
b91bf642 1911# Requires: systemd-units >= 38
575c6f8c 1912
600eea4f 1913%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl daemon-reload || :
575c6f8c 1914
48b92d3c
JR
1915%systemd_service_enable() \
1916 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
cdb851a4 1917 /bin/systemctl preset --preset-mode=enable-only %{*} || : \
48b92d3c
JR
1918 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
1919%{nil}
1920
1921%systemd_service_disable() \
1922 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
1923 /bin/systemctl --quiet disable %{*} || : \
1924%{nil}
1925
55b1f314
JR
1926%systemd_service() \
1927 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
600eea4f 1928 /bin/systemd_booted && /bin/systemctl %{*} || : \
55b1f314
JR
1929%{nil}
1930
48b92d3c
JR
1931%systemd_service_start() \
1932 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
600eea4f 1933 /bin/systemd_booted && /bin/systemctl start %{*} || : \
48b92d3c
JR
1934%{nil}
1935
1936%systemd_service_stop() \
1937 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
600eea4f 1938 /bin/systemd_booted && /bin/systemctl stop %{*} || : \
48b92d3c
JR
1939%{nil}
1940
2aa55885 1941# NOTE: doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
48b92d3c
JR
1942%systemd_service_restart() \
1943 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
600eea4f 1944 /bin/systemd_booted && /bin/systemctl try-restart %{*} || : \
48b92d3c
JR
1945%{nil}
1946
2aa55885 1947# NOTE: doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
55b1f314
JR
1948%systemd_service_reload() \
1949 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
600eea4f 1950 /bin/systemd_booted && /bin/systemctl reload %{*} || : \
55b1f314
JR
1951%{nil}
1952
3303369c 1953# NOTE: this trigger disobeys systemd.preset in favour of RPM_ENABLE_SYSTEMD_SERVICE
22fb5d90
JR
1954%systemd_trigger() \
1955want_enable_service() { \
1956 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1957 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
10c60f81 1958 [ "$(echo /etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service})" = "/etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service}" ] && return 1 \
22fb5d90
JR
1959 return 0 \
1960}\
1961 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
1962 for s in %{*}; do \
1963 if want_enable_service $s; then \
15bb2897 1964 /bin/systemctl enable $s || : \
22fb5d90
JR
1965 fi \
1966 done \
1967%{nil}
1968
4fef3086 1969%systemd_post() \
cc9e4640 1970 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
600eea4f 1971 /bin/systemd_booted && /bin/systemctl daemon-reload || : \
cc9e4640 1972 if [ $1 -eq 1 ]; then \
aa13c88c 1973 /bin/systemctl preset --preset-mode=enable-only %{*} >/dev/null || : \
48b92d3c
JR
1974 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
1975 elif [ -z "$NORESTART" ]; then \
600eea4f 1976 /bin/systemd_booted && /bin/systemctl try-restart %{*} || : \
48b92d3c
JR
1977 else \
1978 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
cc9e4640 1979 fi \
732407b4 1980%{nil}
575c6f8c 1981
4fef3086
ER
1982%systemd_preun() \
1983 if [ $1 -eq 0 ]; then \
48b92d3c 1984 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
600eea4f 1985 /bin/systemd_booted && /bin/systemctl stop %{*} || : \
48b92d3c 1986 /bin/systemctl --quiet disable %{*} || : \
732407b4
JK
1987 fi \
1988%{nil}
575c6f8c 1989
afdaeaf4 1990%systemdunitdir /lib/systemd/system
db74e146 1991%systemduserunitdir /usr/lib/systemd/user
08aa85c3 1992%systemdtmpfilesdir /usr/lib/tmpfiles.d
afdaeaf4 1993
b541a244
JB
1994# BuildRequires: rpmbuild(macros) >= 1.721
1995%journal_catalog_update() [ ! -x /bin/journalctl ] || /bin/journalctl --update-catalog >/dev/null 2>&1 || :
1996
6dc7026b
MB
1997#-----------------------------------------------------------------
1998# Update hardware database index
1999#
2000# Requirements:
2001# BuildRequires: rpmbuild(macros) >= 1.691
2002# Requires: udev-core >= 1:196
2003
2004%udev_hwdb_update() \
2005/sbin/udevadm hwdb --update >/dev/null 2>&1 || : \
2006%{nil}
2007
705210a4
JP
2008# Generate vim help tags file
2009#
2010# Requirements:
2011# BuildRequires: rpmbuild(macros) >= 1.718
2012# Requires(post,postun): /usr/bin/vim
2013# Requires(post,postun): vim-rt >= 4:7.4.2054-2
2014%vim_doc_helptags() \
2015umask 022; \
261c16b9 2016/usr/bin/vim -c ':helptags /usr/share/vim/doc' -c ':q' 2>/dev/null \
705210a4
JP
2017%{nil}
2018
7982022e 2019# EOF
This page took 1.705362 seconds and 4 git commands to generate.